/*
 () 
e-mail: liloi@mail.ru
29/04/06
*/



//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "frmMain.h"
#include "frmPM.h"
#include "frmOrto.h"
#include "frmAbout.h"

#include "lvektor.h"
#include "lrotate.h"

//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"

#define m Main
#define p Main->pb
#define pc Main->pb->Canvas

#define fx Main->pb->Width
#define fy Main->pb->Height

#define sg Main->sg

int ttt;

TMain *Main;

void ClearField() //  
{
    TRect a;
    a.Top = 0;
    a.Left = 0;
    a.Right = p->Width;
    a.Bottom = p->Height;
    pc->Brush->Color = clWhite;
    pc->FillRect(a);
}

void FillField() // "" . 
{

    pc->Pen->Color = clBlack;
    pc->Pen->Width = 1;

    pc->MoveTo(0,fy/2);
    pc->LineTo(fx,fy/2);

    pc->TextOutA(fx/2-10,0,"Y");
    pc->TextOutA(fx-10,fy/2+6,"X");

    pc->MoveTo(fx/2,0);
    pc->LineTo(fx/2,fy);

    int a = 0;

    pc->MoveTo(fx/2,fy/2);
    a = fx/2;

    pc->Pen->Color = clRed;
    pc->Pen->Width = 2;

    while(a<fx)
    {
        pc->MoveTo(a-1,fy/2);
        pc->LineTo(a,fy/2);

        a+=10;
    }

    a = fx/2;

    while(a>0)
    {

        pc->MoveTo(a-1,fy/2-1);
        pc->LineTo(a,fy/2);

        a-=10;
    }

    a = fy/2;

    pc->Pen->Color = clBlue;
    pc->Pen->Width = 2;

    while(a<fy)
    {
        pc->MoveTo(fx/2-1,a-1);
        pc->LineTo(fx/2,a);

        a+=10;
    }

    a = fy/2;

    while(a>0)
    {
        pc->MoveTo(fx/2-1,a-1);
        pc->LineTo(fx/2,a);

        a-=10;
    }

}

void FillVecs() // "" 
{
int xx, yy, a;
TColor cl;

    for(int i=1;i<sg->RowCount;i++)
    {

        a = StrToInt(sg->Cells[2][i]);

        switch(a)
        {
        case 0: cl = clBlack; break;
        case 1: cl = clMaroon; break;
        case 2: cl = clGreen; break;
        case 3: cl = clNavy; break;
        case 4: cl = clPurple; break;
        case 5: cl = clGray; break;
        case 6: cl = clRed; break;
        case 7: cl = clBlue; break;
        case 8: cl = clOlive; break;
        }

        pc->Pen->Color = cl;
        pc->Pen->Width = StrToInt(sg->Cells[3][i]);

        pc->MoveTo(fx/2,fy/2);
        xx = StrToFloat(sg->Cells[0][i])*10;
        yy = StrToFloat(sg->Cells[1][i])*10;
        pc->LineTo((fx/2)+xx,(fy/2)-yy);
    }

    sg->Cells[0][0] = "X";
    sg->Cells[1][0] = "Y";
    sg->Cells[2][0] = "";
    sg->Cells[3][0] = "";
}

//---------------------------------------------------------------------------
__fastcall TMain::TMain(TComponent* Owner)
    : TForm(Owner)
{
}
//---------------------------------------------------------------------------
void __fastcall TMain::anExitExecute(TObject *Sender)
{
    Application->Terminate();
}
//---------------------------------------------------------------------------
void __fastcall TMain::FormPaint(TObject *Sender)
{
    FillField();
    FillVecs();
}
//---------------------------------------------------------------------------

void __fastcall TMain::FormCreate(TObject *Sender)
{

    sg->Cells[0][1]="10";
    sg->Cells[1][1]="10";
    sg->Cells[2][1]="1";
    sg->Cells[3][1]="1";
}
//---------------------------------------------------------------------------

void __fastcall TMain::Button1Click(TObject *Sender)
{
    ClearField();
    FillField();
    FillVecs();
}
//---------------------------------------------------------------------------

void __fastcall TMain::Button2Click(TObject *Sender)
{
sg->RowCount++;
sg->Cells[0][sg->RowCount-1] = "0";
sg->Cells[1][sg->RowCount-1] = "0";
sg->Cells[2][sg->RowCount-1] = "0";
sg->Cells[3][sg->RowCount-1] = "0";
}
//---------------------------------------------------------------------------

void __fastcall TMain::Button3Click(TObject *Sender)
{

    if(sg->RowCount!=2)
    {
        sg->RowCount--;
        ClearField();
        FillField();
        FillVecs();
    }
}
//---------------------------------------------------------------------------

void __fastcall TMain::sgKeyPress(TObject *Sender, char &Key)
{
    if(Key==13)
    {
        ClearField();
        FillField();
        FillVecs();
    }
}
//---------------------------------------------------------------------------

void __fastcall TMain::aPMaExecute(TObject *Sender)
{
    int a = sg->Selection.Top;

    l2vektor Q; // . 
    Q.x = (-1)*StrToFloat(sg->Cells[0][a]); //  .   .
    Q.y = (-1)*StrToFloat(sg->Cells[1][a]); //     

    sg->RowCount++;

    sg->Cells[0][sg->RowCount-1] = FloatToStr(Q.x);
    sg->Cells[1][sg->RowCount-1] = FloatToStr(Q.y);
    sg->Cells[2][sg->RowCount-1] = sg->Cells[2][a];
    sg->Cells[3][sg->RowCount-1] = sg->Cells[3][a];

    ClearField();
    FillField();
    FillVecs();

}
//---------------------------------------------------------------------------

void __fastcall TMain::aRotExecute(TObject *Sender)
{
    PM->Show();
}
//---------------------------------------------------------------------------


void __fastcall TMain::Action1Execute(TObject *Sender)
{
    Application->Terminate();    
}
//---------------------------------------------------------------------------

void __fastcall TMain::Action2Execute(TObject *Sender)
{
    int a = sg->Selection.Top;

    float xx = sg->Cells[0][a]*(-1);
    float yy = sg->Cells[1][a]*(-1);

    sg->RowCount++;

    sg->Cells[0][sg->RowCount-1] = FloatToStr(xx);
    sg->Cells[1][sg->RowCount-1] = FloatToStr(yy);
    sg->Cells[2][sg->RowCount-1] = sg->Cells[2][a];
    sg->Cells[3][sg->RowCount-1] = sg->Cells[3][a];

    ClearField();
    FillField();
    FillVecs();    
}
//---------------------------------------------------------------------------

void __fastcall TMain::Action3Execute(TObject *Sender)
{
    ort->Show();   
}
//---------------------------------------------------------------------------

void __fastcall TMain::Action4Execute(TObject *Sender)
{
    PM->Show();
}
//---------------------------------------------------------------------------


void __fastcall TMain::Action5Execute(TObject *Sender)
{
    About->Show();
}
//---------------------------------------------------------------------------

